Package: BCRANK
Title: Predicting binding site consensus from ranked DNA sequences
Version: 1.74.0
Date: 2010-08-25
Depends: methods
Author: Adam Ameur <Adam.Ameur@genpat.uu.se>
Description: Functions and classes for de novo prediction of transcription factor binding consensus by heuristic search
Maintainer: Adam Ameur <Adam.Ameur@genpat.uu.se>
License: GPL-2
LazyLoad: true
Collate: AllClasses.R AllGenerics.R methods-BCRANKmatch.R
        methods-BCRANKsearch.R methods-BCRANKresult.R BCRANK.R
Imports: Biostrings
Suggests: seqLogo
biocViews: MotifDiscovery, GeneRegulation
git_url: https://git.bioconductor.org/packages/BCRANK
git_branch: RELEASE_3_23
git_last_commit: ef18c99
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 20:47:28 UTC; biocbuild

######################################################
##             INITIALIZE METHOD                    ##
######################################################

## Initialize method for class BCRANKmatch
setMethod("initialize", "BCRANKmatch",
          function(.Object,
                   consensus,
                   bcrankScore,
                   matchVec){
            
            ## Check that consensus is in IUPAC coding
            iupacMatch <- gregexpr("^[ACGTRYKMSWBVDHN]*$",consensus)[[1]]
            
            if(attr(iupacMatch,"match.length") < 0){
              stop(paste(consensus,"not in IUPAC coding."))
            }
            
            ##callNextMethod()

            .Object@consensus <- consensus
            .Object@bcrankScore <- bcrankScore
            .Object@matchVec <- matchVec
            .Object
            
          })

BCRANKmatch <- function(consensus, bcrankScore, matchVec){
  new("BCRANKmatch", consensus=consensus, bcrankScore=bcrankScore, matchVec=matchVec)
}

######################################################
##             DISPLAY METHODS                      ##
######################################################

setMethod("show", "BCRANKmatch", function(object){
    
  cat("\nAn object of class \"BCRANKmatch\"\n\n")
  cat("Consensus:",consensus(object),", bcrankScore:",bcrankScore(object))
  
  cat("\n\nUse methods consensus(object), bcrankScore(object) and matchVector(object) to access object slots.\n\n")
  
})


######################################################
##             ACCESSOR METHODS                     ##
######################################################

setMethod("consensus", "BCRANKmatch", function(object) object@consensus)
setMethod("bcrankScore", "BCRANKmatch", function(object) object@bcrankScore)

setMethod("matchVector", "BCRANKmatch", function(object){
  matchVec <- object@matchVec
  matchVec[which(matchVec>0)] <- 1
  return(matchVec)
})

setMethod("nrMatch", "BCRANKmatch", function(object){
  return(length(which(matchVector(object) != 0)))
})

######################################################
##             INITIALIZE METHOD                    ##
######################################################

BCRANKresult <- function(BCRANKsearchList,nrSeqs,fname, funCall, restarts){

  scores <- sapply(1:length(BCRANKsearchList), function(x){bcrankScore(final(BCRANKsearchList[[x]]))})
  
  ordering <- order(scores,decreasing=TRUE)

  toplistOrdered <- lapply(ordering, function(x){BCRANKsearchList[[x]]})
  
  new("BCRANKresult", toplist=toplistOrdered, nrSeqs=nrSeqs, fname=fname, funCall=funCall, restarts=restarts)
}

######################################################
##             DISPLAY METHODS                      ##
######################################################

setMethod("show", "BCRANKresult", function(object){
    
  cat("\nAn object of class \"BCRANKresult\"\n\n")
  cat(paste("Top",restarts(object),"DNA motifs predicted by BCRANK:\n\n"))
  
  print(toptable(object))

  cat("\n\nUse methods toptable(object) and fname(object) to access object slots.\n\n")
  
})

######################################################
##             ACCESSOR METHODS                     ##
######################################################


setMethod("restarts", "BCRANKresult", function(object){object@restarts})
setMethod("toplist", "BCRANKresult", function(object){object@toplist})
setMethod("fname", "BCRANKresult", function(object){object@fname})
setMethod("funCall", "BCRANKresult", function(object){object@funCall})
setMethod("nrSeqs", "BCRANKresult", function(object){object@nrSeqs})

setMethod("toptable", "BCRANKresult", function(object, i=NULL){
  BCRANKsearches <- toplist(object)

  ## Returns toplist as a data.frame
  if(is.null(i)){
    topConsensuses <- as.character(sapply(BCRANKsearches, function(x){ consensus(final(x)) }))
    topScores <- as.numeric(sapply(BCRANKsearches, function(x){ bcrankScore(final(x)) }))

    return(data.frame("Consensus"=topConsensuses,"Score"=topScores))
  }
  ## Returns the i'th search element in the toplist
  else{
    if(i>0 && i<=restarts(object)){
      return(BCRANKsearches[[i]])
    }
    else{
      stop("Argument i is out of range.")
    }
  }
                        
})

.onLoad <- function(lib, pkg) require("methods", quietly=TRUE)

## Class BCRANKmatch
setClass("BCRANKmatch",
         representation(## IUPAC consensus  
                        consensus="character",
                        ## Score
                        bcrankScore="numeric",
                        ## Vector with consensus occurences in ranked sequences.
                        ## For each region 0,1 or 2, where '2' represents 2 or more.
                        matchVec="numeric"))

## Class BCRANKsearch
setClass("BCRANKsearch",
         representation(
                        ## The resulting BCRANKmatch object
                        final="BCRANKmatch",
                        ## Position weight matrix for the final BCRANKmatch
                        finalPWM="matrix",
                        ## Total number of consensus occurences for the final BCRANKmatch
                        finalNrMatch="numeric",
                        ## A list of BCRANKmatch objects -- The whole search path 
                        searchPath="list",
                        ## Number of iterations from start guess to final
                        nrIterations="numeric"))

## Class BCRANKresult
setClass("BCRANKresult",
         representation(
                        ## The fasta file with ranked DNA sequences
                        fname = "character",
                        ## Number of sequences in fasta file
                        nrSeqs = "numeric",
                        ## The bcrank function call 
                        funCall="character",
                        ## A list of BCRANKsearch objects, ranked by their final scores
                        toplist="list",
                        ## A list of BCRANKsearch objects, ranked by their final scores
                        restarts="numeric"))

######################################################
##             INITIALIZE METHOD                    ##
######################################################

## Initialize method for class BCRANKsearch
setMethod("initialize", "BCRANKsearch",
          function(.Object,
                   final,
                   finalPWM,
                   finalNrMatch,
                   searchPath,
                   nrIterations){

            if(length(finalNrMatch)!=1){
              stop("finalNrMatch should have length 1")
            }
            
            ##callNextMethod()

            .Object@final <- final
            .Object@finalPWM <- finalPWM
            .Object@finalNrMatch <- finalNrMatch
            .Object@searchPath <- searchPath
            .Object@nrIterations <- nrIterations
            .Object

            
          })

BCRANKsearch <- function(final, finalPWM, finalNrMatch, searchPath){
  nrIterations <- length(searchPath)
  
  new("BCRANKsearch", final=final, finalPWM=finalPWM, finalNrMatch=finalNrMatch, searchPath=searchPath, nrIterations=nrIterations)
}

######################################################
##             DISPLAY METHODS                      ##
######################################################

setMethod("show", "BCRANKsearch", function(object){
    
  cat("\nAn object of class \"BCRANKsearch\"\n\n")
  cat(paste("Search path, starting from ",consensus(searchPath(object,1)),":\n\n",sep=""))
  print(searchPath(object))
  cat("\nPosition weight matrix for search result (",consensus(final(object)),"):\n\n",sep="")
  print(pwm(object))
  cat("\n\nUse methods searchPath(object) and pwm(object) to access object slots.\n\n")
  
})

setMethod("plot", signature(x="BCRANKsearch",y="missing"), function(x,y,...){

  args <- list(...)

  ## Read arguments and use defaults if not set
  if(is.null(args[["cex.axis"]]))
    args[["cex.axis"]] <- 1.5
  if(is.null(args[["cex.lab"]]))
    args[["cex.lab"]] <- 1.5
  if (is.null(args[["xlab"]]))
    args[["xlab"]] <- "Ordered regions"
  if (is.null(args[["ylab"]]))
    args[["ylab"]] <- "Consensus occurrences"
  if (is.null(args[["type"]]))
    args[["type"]] <- "l"
  if (is.null(args[["lwd"]]))
    args[["lwd"]] <- 2
  if (is.null(args[["frame.plot"]]))
    args[["frame.plot"]] <- FALSE
  if (is.null(args[["col"]]))
    args[["col"]] <- rainbow(15)
  if (is.null(args[["plot.legend"]]))
    args[["plot.legend"]] <- TRUE 
  if (is.null(args[["scale"]]))
    args[["scale"]] <- FALSE

  scale <- FALSE
  if(args[["scale"]] == TRUE){
    scale <- TRUE
  }
  args[["scale"]] <- NULL
  
  plotLegend <- TRUE 
  if(args[["plot.legend"]] == FALSE){
    plotLegend <- FALSE
  }

  args[["plot.legend"]] <- NULL

  cols <- args[["col"]]
  
  nrIter <- nrIterations(x)
    
  sp <- searchPath(x)
  consensuses <- sp[,"Consensus"]
  bcrankScores <- sp[,"Score"]

  maxMatches <- max(sapply(1:nrIter,function(i){ nrMatch(searchPath(x,i)) }))
  
  for(i in 1:nrIter){
    currentMatch <- searchPath(x,i)
    currentHits <- matchVector(currentMatch)

    if(scale == TRUE){
      currentHits <- currentHits/sum(currentHits)
    }

    colIndex <- i

    if(i > length(cols)){
      colIndex <- (i %% length(cols))
    }
    
    currentCol <- cols[colIndex]
    
    if(i==1){
      if(scale == FALSE){
        if(is.null(args[["ylim"]])){
          args[["ylim"]] <- c(0,maxMatches)
        }
      }
      args[["x"]] <- cumsum(currentHits)
      args[["col"]] <- currentCol
      do.call(plot, args)
      args[["cex.axis"]] <- NULL
      args[["cex.lab"]] <- NULL
      args[["xlab"]] <- NULL
      args[["ylab"]] <- NULL
      args[["frame.plot"]] <- NULL
    }
    else{
      args[["x"]] <- cumsum(currentHits)
      args[["y"]] <- NULL
      args[["col"]] <- currentCol
      do.call(points,args)
    }
  }

  if(plotLegend == TRUE){
    legendPos <- NULL
    if(scale==TRUE){
      legendPos <- "bottomright"
    }
    else{
      legendPos <- "topleft"
    }
    legend(legendPos,cex=1,bty="n",legend=consensuses,col=cols,lty=2,lwd=5, xjust=0)
  }
  
})


######################################################
##             ACCESSOR METHODS                     ##
######################################################


setMethod("final", "BCRANKsearch", function(object){object@final})
setMethod("finalPWM", "BCRANKsearch", function(object){object@finalPWM})
setMethod("finalNrMatch", "BCRANKsearch", function(object){object@finalNrMatch})
setMethod("nrIterations", "BCRANKsearch", function(object){object@nrIterations})

setMethod("pwm", "BCRANKsearch", function(object, normalize=TRUE){
  pwm <- finalPWM(object)
  if(normalize){
    pwm <- pwm/finalNrMatch(object)
  }
  return(pwm)
})

setMethod("searchPath", "BCRANKsearch", function(object, i=NULL){
  BCRANKmatches <- object@searchPath

  ## Returns search path as a data.frame
  if(is.null(i)){
    pathConsensuses <- as.character(sapply(BCRANKmatches, function(x){ consensus(x) }))
    pathScores <- as.numeric(sapply(BCRANKmatches, function(x){ bcrankScore(x) }))

    return(data.frame("Consensus"=pathConsensuses,"Score"=pathScores))
  }
  ## Returns the i'th search element in the toplist
  else{
    if(i>0 && i<=nrIterations(object)){
      return(BCRANKmatches[[i]])
    }
    else{
      stop("Argument i is out of range.")
    }
  }
})
          

###############################################################################
##
## File: BCRANK.R
##
## predicting binding site consensus from ranked DNA sequences
##
## Author: Adam Ameur, Uppsala Univ., Sweden
##
## Description: Implementation of an algorithm for detection of short DNA
##   sequences that are overrepresented in some part of the list. Starting from
##   some initial consensus DNA sequence coded in IUPAC symbols, the method uses
##   a heuristic search to improve the consensus until a local optimum is found.
## 
## Dependencies: Biostrings
##
################################################################################

####################### Help functions ######################### 

## IUPAC symbols for nucleotides
iupac <- c("N","A","C","G","T","R","Y","K","M","S","W","B","D","H","V")
names(iupac) <- c("ACGT","A","C","G","T","AG","CT","GT","AC","CG","AT","CGT","AGT","ACT","ACG")

## IUPAC symbols represented as a list
iupacAsList <- list("A"=c("A"),"C"=c("C"),"G"=c("G"),"T"=c("T"),"R"=c("A","G"),"Y"=c("C","T"),"K"=c("G","T"),"M"=c("A","C"),"S"=c("C","G"),"W"=c("A","T"),"B"=c("C","G","T"),"D"=c("A","G","T"),"H"=c("A","C","T"),"V"=c("A","C","G"),"N"=c("A","C","G","T"))

## Converts a string of IUPAC symbols to a consensus sequence
iupacToCons <- function(iupacString){

  iupacToBase <- function(base){
    if(base == "A" || base == "C" || base == "G" || base == "T")
      return(base)
    else{
      cons <- names(iupac[which(iupac == base)])
      return(paste("[",cons,"]",sep=""))
    }
  }
  
  iupacByPos <- strsplit(iupacString,"")[[1]]
  cons <- ""
  for(i in 1:length(iupacByPos)){
    cons <- paste(cons, iupacToBase(iupacByPos[i]),sep="")
  }
  return(cons)
} 


## Returns the reverse complement of a IUPAC or consensus sequence
revComp <- function(seq){
    
  baseComp <- array(NA,0)
  baseComp[c("A","C","G","T","R","Y","K","M","S","W","B","V","D","H","N","[","]","(",")")] <- c("T","G","C","A","Y","R","M","K","S","W","V","B","H","D","N","]","[",")","(")
  
  return(paste(rev(sapply(strsplit(toupper(seq),"")[[1]],function(x){
    if(!is.na(baseComp[x]))
      {
        return(baseComp[x])
      }else{
        return(x)
      }
  },USE.NAMES = FALSE)),collapse = ""))
}

## Trims leading and trailing white space from character strings.
trimWhiteSpace <- function(x){
    sub("[ \t\n\r]*$", "", sub("^[ \t\n\r]*", "", x))
}

## Removes all letters 'N' at the beginning and end of a string
trimNs <- function(consensus){
  return(sub("N*$", "", sub("^N*", "", consensus)))
}

## Adds n 'N' letters at the beginning and end of a string
addNs <- function(consensus,n){
  consensus <- paste(paste(rep("N",n),collapse=""),consensus,paste(rep("N",n),collapse=""),sep="")
  return(consensus)
}

## Reads sequences from a FASTA file and checks the file format.
seqFromFile <- function(fafile){

  ## Read sequences using Biostings package
  seqs <- try(readDNAStringSet(fafile), silent=TRUE)
  
  ## Report error
  if(class(seqs) == "try-error"){
    stop(paste("Error reading fasta file:",fafile))
  }
  
  seqs <- as.character(seqs)

  return(seqs)
}


## Creates a position weight matrix (PWM) given sequences and a
## IUPAC consensus sequence. 
createPWM <- function(seqs, consensus, matchRevComp=TRUE){

  ## Create a position weight matrix as used by seqLogo
  createPWMhelp <- function(match, seqs, motifLength, isRevComp=FALSE){

    ## Detect all matching DNA sequences
    
    allTBS <- matrix(0, nrow=4,ncol=motifLength, dimnames=list(c("A","C","G","T"),1:motifLength))
    
    for(i in 1:length(match)){
      currentMatch <- match[[i]]
      TBS <- NULL

      if(currentMatch[1] > -1){
        seq <- seqs[i]
        for(j in 1:length(currentMatch)){
          posInRegion <- as.integer(currentMatch[j])
          matchLength <- attr(currentMatch,"match.length")[j]-1

          TBS <- as.character(substr(seq,posInRegion,posInRegion+matchLength))

          if(isRevComp==TRUE){
            TBS <- revComp(TBS)
          }
        }
        TBSasPWM <- sapply(strsplit(TBS,"")[[1]], function(x){
          if(x=="A"){
            return(c(1,0,0,0))
          }
          if(x=="C"){
            return(c(0,1,0,0))
          }
          if(x=="G"){
            return(c(0,0,1,0))
          }
          if(x=="T"){
            return(c(0,0,0,1))
          }
        })
        allTBS <- allTBS+TBSasPWM
      }
    }

    return(allTBS)
  }
  
  motifLength <- nchar(consensus)
    
  motifSequence <- iupacToCons(consensus)
   
  match <- gregexpr(motifSequence,seqs)
  pwm <- createPWMhelp(match, seqs, motifLength)
  
  if(matchRevComp == TRUE){
    RCmotifSequence <- revComp(motifSequence)
    matchRC <- gregexpr(RCmotifSequence,seqs)
    pwm_rc <- createPWMhelp(matchRC, seqs, motifLength,isRevComp=TRUE)
    pwm <- pwm+pwm_rc
  }

  return(pwm)

}


## Given a fasta file and a motif in IUPAC coding, the function makes a
## call to a C function that detects all occurences of the motif in the
## sequences. Number of sequences and the sequence lengths are required
## as arguments so that the C function can allocate enough memory.
matchConsensus <- function(seqs, motif, nrSeqs, seqLengths, maxOccurences=2){
  RCmotif <- revComp(motif)
  motifLength <- nchar(motif)
  RCmotif <- revComp(motif)
  
  hits <- .C("match_consensus", as.character(seqs), as.character(motif), as.character(RCmotif), as.integer(motifLength),  as.integer(nrSeqs), as.integer(seqLengths), as.integer(maxOccurences), result=as.integer(rep(0,nrSeqs)))$result
  
  return(hits)
}


## Given a fasta file and a motif in IUPAC coding, the function detects all
## occurences of the motif for all consensus sequences in the neighbourhood
## of the given motif.
hitsForNeighboursInC <- function(seqs, consensus, nrSeqs, seqLengths, silent){

  hitsForNeighboursByBase <- function(seqs, consensus, basePos, nrSeqs, seqLengths){

    ## Swap base at basePos to newBase
    swapBase<-function(consensus, basePos, newBase){
      consensusByPos <- strsplit(consensus,"")[[1]]
      
      prefix <- substr(consensus, 1, basePos-1)
      suffix <- substr(consensus, basePos+1, length(consensusByPos))
      
      return(paste(prefix,newBase,suffix,sep=""))
    }
    
    consensusByPos <- strsplit(consensus,"")[[1]]
    oldBase <-  substr(consensus, basePos, basePos)
    
    ## Consensus where base at position has been changed
    ## to A,C,G or T
    swappedA <- swapBase(consensus,basePos,"A")
    swappedC <- swapBase(consensus,basePos,"C")
    swappedG  <- swapBase(consensus,basePos,"G")
    swappedT <- swapBase(consensus,basePos,"T")
    
    basicHits <- list()
    basicHits[[swappedA]] <- matchConsensus(seqs, motif=swappedA, nrSeqs=nrSeqs, seqLengths=seqLengths)
    basicHits[[swappedC]] <- matchConsensus(seqs, motif=swappedC, nrSeqs=nrSeqs, seqLengths=seqLengths)
    basicHits[[swappedG]] <- matchConsensus(seqs, motif=swappedG, nrSeqs=nrSeqs, seqLengths=seqLengths)
    basicHits[[swappedT]] <- matchConsensus(seqs, motif=swappedT, nrSeqs=nrSeqs, seqLengths=seqLengths)
    
    hits <- list()
    
    newBases <- iupac[!(iupac %in% oldBase)]
    
    for(base in newBases){
      newCons <- swapBase(consensus, basePos, base)
      atomicBases <- iupacAsList[[base]]
      tmpHits <- rep(0,nrSeqs)
      for(baseTmp in atomicBases){
        consTmp <- swapBase(consensus, basePos, baseTmp)
        tmpHits <- tmpHits+basicHits[[consTmp]]
      }
      hits[[newCons]] <- tmpHits
    }
    
    return(hits)
  }

  consLength <- nchar(consensus)
  hits <- list()

  if(!silent){
    cat("Scanning sequences")
    flush.console()
  }
  
  for(basePos in 1:consLength){
    if(!silent){
      cat(".")
      flush.console()
    }
    hits <- append(hits,hitsForNeighboursByBase(seqs,consensus,basePos,nrSeqs,seqLengths))
  }

  if(!silent){
    cat("\n")
    flush.console()
  }
  
  return(hits)
}


#################### Neighbourhood #######################################

## Returns all consensus sequences in the neighbourhood of a given consensus
getBCRANKNeighbours <- function(consensus){
    
    consensusByPos <- strsplit(consensus,"")[[1]]
    
    neighbours <- array(NA)
    
    for(i in 1:length(consensusByPos)){
      prefix <- substr(consensus, 1, i-1)
      suffix <- substr(consensus, i+1, length(consensusByPos))
      
    newBases <- iupac[!(iupac %in% consensusByPos[i])]
      neighbours <- c(neighbours,paste(prefix,newBases,suffix,sep=""))
    }
  
    return(neighbours[which(!is.na(neighbours))])
  }

######################## Cost function ####################################

## Computes the BCRANK score of a consensus sequence
getBCRANKScore<-function(hitsVec, randOrder, consensus, use.P1, use.P2, nrPoints=25){
  
  ## Given the observed hits and the random orderings, the function returns
  ## the differences between the observed hits and each of the random
  ## orderings. Each difference is computed by comparing the cumulative
  ## hit functions at a number of uniformly distributed points in the interval.
  getDeviationsFromRandom <- function(hits, randOrder, nrPoints){

    points <- round(seq(1,length(hits),length.out=nrPoints))
    
    randHits <- sapply(1:ncol(randOrder), function(i){
      cumsum(hits[randOrder[,i]])[points]
    })

    obsHits <- cumsum(hits)[points]
    dists <- (obsHits - randHits)
        
    return(colSums(dists))
  }

  ## ###############
  ##
  ## Compute score
  ##
  ## ###############
  
  hitsLen <- length(hitsVec)
  hitsUnique <- rep(0,hitsLen)
  matchingIds <- which(hitsVec>0)
  nrHits <- length(matchingIds)

  ## Return negative score if motif is matching in none or all sequences
  if(nrHits == hitsLen || nrHits == 0){
    return(-100)
  }

  ## Make the hits vector conatin only 0's and 1's
  hitsUnique[matchingIds] <- 1
  hitsUnique <- hitsUnique/sum(hitsUnique)

  ## Compute significance score for the hits vector, by comparing to scores
  ## for random orderings using a t-test. 
  randDists <- getDeviationsFromRandom(hitsUnique, randOrder, nrPoints=nrPoints)
  tval <- abs(t.test(randDists,mu=0)$statistic)

  score <- tval
  
  ## #######################
  ##
  ## Compute score penalties.
  ##
  ## #######################
  
  ## Compute P1 - Penalty on non-specific bases

  if(use.P1){
    
    tmpConsensus <- trimNs(consensus)

    tmpConsensus <- gsub("A","X",tmpConsensus)
    tmpConsensus <- gsub("C","X",tmpConsensus)
    tmpConsensus <- gsub("G","X",tmpConsensus)
    tmpConsensus <- gsub("T","X",tmpConsensus)
    
    nrSpecific <- length(which(gregexpr("X",tmpConsensus)[[1]]!=-1))

    ## Avoid zero penalty for motifs with no A,C,G or T bases
    if(nrSpecific == 0){
      nrSpecific <- 0.5
    }

    P1 <-  nrSpecific/nchar(tmpConsensus)

    score <- score*P1

  }
    
  ## Compute P2 - Penalty on repetitive motifs
  if(use.P2){

    nrMultipleHits <- length(which(hitsVec>1))

    P2 <- 1-(nrMultipleHits/nrHits)

    score <- score*P2
  }
  
  return(score)
}


############################ Run search algorithm ###################################

## Runs the BCRANK search on a fasta file containing ranked DNA regions starting from
## an initial consensus sequence. The nrRandom parameter specifies the number of random
## re-orderings performed to calculate scores. Returns a BCRANKsearch object
bcrankRun <- function(seqs, start, nrRandom=500, silent=FALSE, makePlot=FALSE, do.search=TRUE, use.P1=TRUE, use.P2=TRUE){
    
  nrSeqs <- length(seqs)
  seqLengths <- as.numeric(unlist(lapply(seqs,nchar)))

  if(!silent){
    if(do.search){
      cat("\n**** Running BCRANK on",nrSeqs,"regions, starting from",start,"****\n")
    }
    else{
      cat("\n**** Computing BCRANK score for",start,"on",nrSeqs,"regions ****\n")
    }
    flush.console()
  }
  
  ## A list BCRANKmatch objects
  searchPath <- list()
    
  iteration <- 0 

  randOrder <-  sapply(1:nrRandom, function(x){
    sample(1:length(seqs))
  })

  ## A list with the consensus sequences that have alredy scores assigned to them.
  seenMotifs <- list()
  
  hits <- matchConsensus(seqs, motif=start, nrSeqs=nrSeqs, seqLengths=seqLengths)
  score <- getBCRANKScore(hits,randOrder,start, use.P1, use.P2)

  seenMotifs[[start]] <- score
    
  improvement <- TRUE
  iteration <- 0
  bestScore <- score
  bestCons <- start
  bestHits <- hits

  while(improvement){
    
    improvement <- FALSE
    iteration <- iteration+1
    
    searchPath[[iteration]] <- BCRANKmatch(as.character(bestCons),as.numeric(bestScore),as.numeric(bestHits))
    
    if(makePlot){
      ## Create a temporary BCRANKsearch object and plot it
      tmp_final <- searchPath[[iteration]]
      tmp_finalPWM <- matrix(NA)
      tmp_finalNrMatch <- 0
      tmp_searchObj <- BCRANKsearch(tmp_final, tmp_finalPWM, tmp_finalNrMatch, searchPath)
      plot(tmp_searchObj) 
    }

    if(do.search){
      if(!silent){
        cat("\nIteration ",iteration," - ",bestCons,": ",bestScore,"\n",sep="")
        flush.console()
      }
      
      ## Add flanking N's to the current best consensus
      bestCons <- addNs(bestCons,n=1)
      
      ## Generate neighbourhood around current best consensus
      neighbours <- getBCRANKNeighbours(bestCons)
      
      hitsNeigh <- hitsForNeighboursInC(seqs, bestCons, nrSeqs=nrSeqs, seqLengths=seqLengths, silent=silent)
      
      nrNeigh <- length(hitsNeigh)
      nrDone <- 0

      if(!silent){
        cat("Computing scores")
        flush.console()
      }
      
      for(consensus in names(hitsNeigh)){
        hits <- hitsNeigh[[consensus]]
        score <- NULL
        if(consensus %in% names(seenMotifs)){
          score <- seenMotifs[[consensus]]
        }
        else{
          score <- getBCRANKScore(hits,randOrder,consensus,use.P1,use.P2)
          seenMotifs[[consensus]] <- score
        }
        
        if(!is.nan(score)){
          if(score > bestScore){
            bestScore <- score
            bestCons <- trimNs(consensus)
            bestHits <- hits
            improvement <- TRUE
          }
        }
        
        nrDone <- nrDone+1
        
        if(!silent){
          ## Don't report all computed scores
          if((nrDone %% 10) == 0){
            cat(".")
            flush.console()
          }
        }
      }
      if(!silent){
        cat("\n")
        flush.console()
      }
    }
    ## Don't run the search
    else{
      improvement <- FALSE
    }
  }

  ## Create BCRANKmatch object for current best consensus and store in list
  final <- searchPath[[iteration]]
  finalPWM <- createPWM(seqs,consensus(final))
  finalNrMatch <- unique(colSums(finalPWM))
  
  ## Returns a BCRANKsearch object
  searchResult <- BCRANKsearch(final, finalPWM, finalNrMatch, searchPath)

  return(searchResult)
}


## Runs the BCRANK algorithm.
bcrank <- function(fafile, startguesses=c(), restarts=10, length=10, reorderings=500, silent=FALSE, plot.progress=FALSE, do.search=TRUE, use.P1=FALSE, use.P2=TRUE, strip.desc=TRUE){
    
  if (!identical(strip.desc, TRUE))
      warning("'strip.desc' argument is ignored")

  ## A list containing BCRANKsearch objects
  BCRANKsearchResults <- list()
  
  ## Read sequences from file
  seqs <- seqFromFile(fafile)
    
  ## Generates a random consensus sequence in IUPAC encoding.
  getRandomInit <- function(length=10){
    return(paste(sample(iupac,length,replace=TRUE),collapse=""))
  }
  
  ## Multiple random search
  if(length(startguesses)==0){
    for(i in 1:restarts){
      BCRANKsearchResults[[i]] <- bcrankRun(seqs, nrRandom=reorderings, start=getRandomInit(length),silent=silent, makePlot=plot.progress, do.search=do.search, use.P1=use.P1, use.P2=use.P2)
    }
  }

  ## Search from given startguesses (coded in IUPAC)
  else{
    restarts <- length(startguesses)
    for(i in 1:restarts){
      BCRANKsearchResults[[i]] <- bcrankRun(seqs, nrRandom=reorderings, start=startguesses[i], silent=silent, makePlot=plot.progress, do.search=do.search, use.P1=use.P1, use.P2=use.P2)
    }
  }

  ## Return BCRANKresult object
  funCallString <- as.character(sys.call())
  result <- BCRANKresult(BCRANKsearchResults, length(seqs), fafile, funCallString, restarts)
  
  return(result)
}



################### Report macthing sites in a fasta file ############################
matchingSites <- function(fafile, motifSequence, revComp=TRUE, strip.desc=TRUE){
  
  if (!identical(strip.desc, TRUE))
      warning("'strip.desc' argument is ignored")

  reportMatch <- function(match, seqs, strand){

    siteInfo <- NULL
    
    for(i in 1:length(match)){
      currentMatch <- match[[i]]
      
      if(currentMatch[1] > -1){
        seqNr <- i
        header <- names(seqs)[i]

        seq <- seqs[i]
        
        for(j in 1:length(currentMatch)){
          posStart <- as.integer(currentMatch[j])
          matchLength <- attr(currentMatch,"match.length")[j]-1
          posEnd <- as.integer(posStart+matchLength)

          DNAseq <- as.character(substr(seq,posStart,posEnd))
          
          siteInfo <- rbind(siteInfo, c(header, seqNr, posStart, posEnd, strand, DNAseq))
          
        }
      }
    }
    return(siteInfo)
  }
  
  seqs <- seqFromFile(fafile)
    
  motifSequence <- iupacToCons(motifSequence)
  tmpMatch <- gregexpr(motifSequence,seqs,perl=TRUE)
  match <- reportMatch(tmpMatch, seqs, strand="+")
  
  if(revComp){
    RCmotifSequence <- revComp(motifSequence)
    tmpMatchRC <- gregexpr(RCmotifSequence,seqs,perl=TRUE)
    rcMatch <- reportMatch(tmpMatchRC, seqs, strand="-")

    match <- rbind(match,rcMatch)
  }

  match <- match[order(as.integer(match[,2])),]
  
  match[,2] <- paste("seq",match[,2],sep="")

  match <- as.data.frame(match)
  
  colnames(match) <- c("Region header","Region nr","Start","End","Strand","Sequence")

  return(match)

}

## GENERIC ACCESSOR METHODS:

## BCRANKmatch
setGeneric("consensus", function(object) standardGeneric("consensus"))
setGeneric("bcrankScore", function(object) standardGeneric("bcrankScore"))
setGeneric("matchVector", function(object) standardGeneric("matchVector"))
setGeneric("nrMatch", function(object) standardGeneric("nrMatch"))

## BCRANKsearch
setGeneric("final", function(object) standardGeneric("final"))
setGeneric("finalPWM", function(object) standardGeneric("finalPWM"))
setGeneric("finalNrMatch", function(object) standardGeneric("finalNrMatch"))
setGeneric("nrIterations", function(object) standardGeneric("nrIterations"))
setGeneric("searchPath", function(object, i=NULL) standardGeneric("searchPath"))
setGeneric("pwm", function(object, normalize=TRUE) standardGeneric("pwm"))

## BCRANKresult
setGeneric("fname", function(object) standardGeneric("fname"))
setGeneric("nrSeqs", function(object) standardGeneric("nrSeqs"))
setGeneric("funCall", function(object) standardGeneric("funCall"))
setGeneric("toplist", function(object) standardGeneric("toplist"))
setGeneric("restarts", function(object) standardGeneric("restarts"))
setGeneric("toptable", function(object, i=NULL) standardGeneric("toptable"))

%\VignetteIndexEntry{BCRANK}
%\VignetteDepends{}
%\VignetteKeywords{}
%\VignettePackage{BCRANK}

\documentclass[10pt,a4paper]{article}

\setlength{\oddsidemargin}{0.3cm} %margin
\setlength{\evensidemargin}{0.3cm} %margin
\setlength{\textwidth}{15.2cm}
\addtolength\footskip{1cm}
\pagestyle{plain}

\usepackage{Sweave}
\usepackage{graphicx}
\usepackage[small]{caption}

\setkeys{Gin}{width=0.6\textwidth}

\title{BCRANK: predicting binding site consensus from ranked DNA sequences}

\author{Adam Ameur}

\date{\today}

\begin{document}

\maketitle


\section{Introduction}

This document describes the \texttt{BCRANK} \texttt{R} package. \texttt{BCRANK}\cite{Ameur09} 
is a method that takes a ranked list of genomic regions as input and outputs short DNA sequences 
that are overrepresented in some part of the list. The algorithm was developed 
for detecting transcription factor (TF) binding sites in a large number of enriched 
regions from high-throughput ChIP-chip or ChIP-seq experiments, but it 
can be applied to any ranked list of DNA sequences. 

\subsection{Input data}
BCRANK takes a fasta file with DNA sequences as input:
\begin{itemize}
\item{The sequences in the file must be ordered, with the ones most likely to contain a TF binding sequence at the top.}
\item{The sequences may be of varying lengths. Usually the average length is somewhere in the range between 50bp and 2kb.}
\item{All IUPAC nucleotide symbols are allowed in the sequences, but positions with other letters than $(A,C,G,T)$ will not be considered in the motif search.}
\end{itemize}

\subsection{The algorithm}
\texttt{BCRANK} uses a heuristic search strategy. First a score is computed for an 
initial short consensus sequence, typically selected at random. The score takes into 
account both the number of consensus occurrences and the rank of the genomic regions. 
Then all consensus sequences in a neighborhood of the start guess are evaluated and the one 
with highest score is kept as the starting point for the next iteration. 
When a local optimum is found, the algorithm is terminated and the 
locally optimal consensus is reported as a result. In order to increase the 
chance of detecting the globally optimal solution, the algorithm may be restarted
several times using different random starting points. Alternatively, \texttt{BCRANK} 
can be used for assigning scores to previously established consensus sequences. The sections 
below describe in more detail how the neighborhood, scoring function and start guess are 
implemented. 

\texttt{BCRANK} can extend and shorten motifs and can therefore be used in situations 
where the motif length is not known a priori. Moreover, \texttt{BCRANK} implements two 
optional penalties that can give relatively higher scores some consensus sequences. The 
effect of the penalties is that i) the consensus contains fewer redundant bases (i.e. other 
bases than ${A,C,G,T}$), and ii) the consensus will not be frequently occurring as a repetitive 
element in the enriched regions. 

\subsubsection{Neighborhood}
In BCRANK, all consensus sequences are represented by IUPAC nucleotide symbols. The neighborhood of one consensus sequence $s$ consists of all consensuses that can be generated from s by first adding one IUPAC letter N (representing any nucleotide) to either side of $s$ and then flipping any base to any other IUPAC symbol. Since there are 15 symbols in total, a sequence of length $l$ will have $14 \cdot (l+2)$ neighbors. After each search step any flanking Ns are removed from the highest scoring sequence in the neighborhood. The removal and additions of flanking Ns allows the algorithm to shorten and extend the predicted binding sites.

\subsubsection{Scoring function}
The score tells whether a given consensus sequence is overrepresented in some part of the ranked list or not. Starting from $N$ ranked regions and a consensus sequence $c$, a binary vector of size $N$ is created, with 1 at position $i$ if $c$ is occurring in sequence number $i$, and 0 if not. The reverse complement of $c$ is also allowed to match. Then the cumulative sum of the match vector is computed and stored in a vector called $A$. The $A$-vector tells where in the ranked list most occurrences are located (see Figure~\ref{fig:intro1}).
\begin{figure}[h]
  \center
  \includegraphics[height=4.2cm,width=7.7cm]{BCRANK_intro_fig1}
  \caption{$A$-vectors for the two consensus sequences \texttt{CACGTGAC} (left) and \texttt{CAGGCTGG} (right). On the x-axis are the top 5211 regions from a whole genome ChIP-chip study on USF1 in human liver cells\cite{Rada08}, ranked by their enrichment signal. The aim of \texttt{BCRANK} is to detect sequences that are biased towards some part of the list. Therefore \texttt{CACGTGAC} will get a higher score than \texttt{CAGGCTGG} even though it has a lower number of total occurrences. It is important to have enough number of ranked input regions to \texttt{BCRANK}, so this bias is observed for the correct binding motif. The established USF1 binding sequence is \texttt{CACGTG}.}
  \label{fig:intro1}
\end{figure}


To compute a score, $A$ is compared to what it would look like if the genomic regions were randomly ordered. Therefore a large number $R$ (the \texttt{reorderings} parameter to \texttt{bcrank()}) of random orderings of the input regions are generated, and a corresponding vector $A_j$ is computed for each re-ordering $1 \le j \le R$ as above. For each $j$, the difference $D_j$ between $A_j$ and $A$ is estimated by the area between the corresponding lines (see Figure~\ref{fig:intro2}). When calculating $D_j$, the $A$ and $A_j$ vectors are first scaled so they range between 0 and 1. 
\begin{figure}[h]
  \center
  \includegraphics[height=4.5cm,width=8.25cm]{BCRANK_intro_fig2}
  \caption{The vector $A$ (red line) and a corresponding vector $A_j$ (blue line) for \texttt{CACGTGAC} in the USF1 data. There is a clear bias towards the high scoring sequences as indicated by the red line. The significance of this bias can be estimated by comparing to the \texttt{CACGTGAC}-occurrences in randomly ordered regions, as indicated by the blue line. $D_j$ corresponds to the grey area between the two lines.}
  \label{fig:intro2}
\end{figure}


$D_j$ will be close to zero when the consensus occurrences are distributed as expected by random sampling. If on the other hand all $D_j$ are far off from zero, $c$ is biased towards some part of the list. Therefore the score is calculated as the t-statistic $T$ for the $D_j$ being drawn from a distribution centered around zero. Consensus sequences that are biased towards some part of the list will thus get high scores whereas consensuses with no bias will get low scores. Moreover, consensuses that are matching just a few regions will not get a high $T$ even if it is matching only among the top ranked regions. This is because there will be a high variation within the $D_j$ values which will result in a low $T$.
\subsubsection*{Penalties}
The t-statistic gives consensus sequences that are biased towards some part of the list. But there may be other issues to take into account if the aim is to detect TFBS from ChIP-chip or ChIP-seq data. Therefore, \texttt{BCRANK} implements two optional penalties, $P1$ and $P2$, with values between 0 and 1. The final scoring function is defined as: $score = T \cdot P1 \cdot P2$. If a penalty is not used it will be set to 1.
\begin{itemize}
\item $P1$ - Penalty on non-specific bases. Let $l$ be the length of the consensus sequence and $b$ the total number of fixed bases (A, C, G, T) in the sequence. If there are no fixed bases, $b$ is set to 0.5.  The penalty is then defined as $P1=b/l$.
\item $P2$ - Penalty on repetitive motifs. Let $r_n, n \in {1,2}$ be the number of input DNA regions that contain at least $n$ occurrences of the consensus. Then $P2=1-(r_2/r_1)$. 
\end{itemize}

\subsubsection{Start guess}
In case the algorithm is used for ab inito search, the initial guess is a randomly generated consensus of a specified length (the \texttt{length} parameter to \texttt{bcrank()}), with 10 bases as default. Multiple restarts with different random start guesses are usually required to increase the chance of finding the globally optimal solution. The number of restarts is determined by the \texttt{restarts} parameter.

\texttt{BCRANK} can also use start guesses passed to \texttt{bcrank()} by the \texttt{startguesses} parameter. By setting the \texttt{do.search} parameter to \texttt{FALSE}, \texttt{BCRANK} assigns scores for the given start guesses without performing any search. 

\subsection{Additional information}
Some other important details:
\begin{itemize}
\item{The algorithm randomly re-orders the data when the score is calculated. This implies that the same consensus sequence will get different \texttt{BCRANK} scores in the same data when run with different re-orderings. The variability in scores can be decreased by increasing the \texttt{reorderings} parameter}
\item{The algorithm performs a breadth-first search, meaning that the highest scoring neighbor in the neighborhood is selected in each search step.}
\item{The algorithm keeps track of all consensus sequences that have already been tested so the same sequence is not visited twice when performing a search.}
\end{itemize}

\subsection{Citation}
To cite \texttt{BCRANK}, please use (Ameur et al, 2009), see \cite{Ameur09} in the References section.  
\newpage

\section{BCRANK - An example run}
The user is required to load the package using the \texttt{library()} command:
<<load, echo=TRUE>>=
library(BCRANK) 
@ 

\subsection{Sequence data}

\texttt{BCRANK} takes a fasta file containing ranked sequences as input. The command below loads an example file containing 2500 ranked regions from a whole genome ChIP-chip experiment for the protein USF1 in the human liver cell line HepG2\cite{Rada08}.  
<<loadFasta>>=   
fastaFile <- system.file("Exfiles/USF1_small.fa", package="BCRANK")
@ 

\subsection{Running BCRANK}

The \texttt{bcrank()} function call below runs the \texttt{BCRANK} algorithm on the example USF1 data set. The \texttt{set.seed()} call sets seed for the random number generator for reproducibility. \\\\
\noindent{\texttt{> set.seed(0)}}\\
\noindent{\texttt{> BCRANKout <- bcrank(fastaFile, restarts=25, use.P1=TRUE, use.P2=TRUE)}}\\ 

\noindent{Since it takes some time to run the algorithm, results can instead be loaded from a previous run on a larger USF1 data set containing the top 5211 regions:} 

<<loadResult>>=   
data(BCRANKout)
@ 

\subsection{BCRANK output}

An object of type \texttt{BCRANKresult} is returned:

<<viewBCRANKresult>>=   
BCRANKout
@ 

\subsubsection{The \texttt{BCRANKsearch} object}

\noindent{Use the \texttt{toptable()} function to access information about each motif found by \texttt{bcrank}. It returns an object of type \texttt{BCRANKsearch}:}. Here we extract the top scoring motif:

<<viewTopMotif>>=   
topMotif <- toptable(BCRANKout,1)
topMotif
@  

\noindent{The \texttt{pwm()} function returns the position weight matrix for the search result. If \texttt{normalize} is set to \texttt{TRUE} each column will sum to \texttt{1}. 
  
<<viewWM>>=   
weightMatrix <- pwm(topMotif, normalize=FALSE)
weightMatrix
@  

\noindent{A weight matrix can be viewed as a sequence logo by using the \texttt{seqLogo} package. Make sure that that the pwm is normalized before running the \texttt{seqLogo()} function.

\begin{center}
<<label=fig1, fig=TRUE>>=
weightMatrixNormalized <- pwm(topMotif, normalize=TRUE)
library(seqLogo)
seqLogo(weightMatrixNormalized)
@ 
\end{center}

\noindent{The search path can be visualized. For each consensus in the search path, the number of occurences among the ranked regions are plotted. As seen in the figure, \texttt{BCRANK} searches for consensus sequences that don't give straight lines.}


\begin{center}
<<label=fig2, fig=TRUE>>=
plot(topMotif)
@
\end{center}

\subsubsection{Predicted binding sites}

\noindent{Individual predicted binding sites can be reported by the \texttt{matchingSites} function.

<<reportSites>>=   
topConsensus <- as.character(toptable(BCRANKout)[1,"Consensus"])
print(topConsensus)
bindingSites <- matchingSites(fastaFile,topConsensus)
nrSites <- nrow(bindingSites)
cat("Number predicted binding sites:",nrSites,"\n")
print(bindingSites[1:15,])
@  

\noindent{As seen in the example above, some binding sites can be reported both on the sense and anti-sense strands. If the consensus is palindromic, duplicate enries can be avoided by setting the \texttt{revComp} argument in the \texttt{matchingSites()} call to \texttt{FALSE}.}

\bibliographystyle{plainnat}

\begin{thebibliography}{}

\bibitem[1]{Ameur09}
 Ameur, A., Rada-Iglesias, A., Komorowski, J., Wadelius, C.\begin{em} Identification of candidate regulatory SNPs by combination of transcription factor binding site prediction, SNP genotyping and haploChIP.\end{em} Nucleic Acids Res, 2009, 37(12):e85.

\bibitem[2]{Rada08}
Rada-Iglesias, A., Ameur, A., Kapranov, P., Enroth, S., Komorowski, J., Gingeras, T. R., Wadelius, C.\begin{em} Whole-genome maps of USF1 and USF2 binding and histone H3 acetylation reveal new aspects of promoter structure and candidate genes for common human disorders.\end{em} Genome Res, 2008, 18(3):380-92.


\end{thebibliography}


\end{document}
 
 
 
 

\name{matchingSites}
\docType{methods}
\alias{matchingSites}

\title{Report IUPAC consensus occurrences in a fasta file}

\description{
  This function reports all occurrences of a consensus sequence in a fasta
  file. It can be used to extract transcription factor binding sites
  predicted by BCRANK or other motif search methods.
}

\usage{
matchingSites(fafile, motifSequence, revComp=TRUE, strip.desc=TRUE)
}

\arguments{
  \item{fafile}{a ranked fasta file containing DNA sequences.} 
  \item{motifSequence}{a character vector in IUPAC coding representing a
	DNA sequence.}
  \item{revComp}{set to TRUE if the reverse complement also be matched.}
  \item{strip.desc}{Ignored (always treated as TRUE).}
}

\value{
  Returns a data frame with positions, strand and DNA sequence for the
  matching sites.
}

\author{Adam Ameur, \email{adam.ameur@genpat.uu.se}}

\seealso{
  \code{\link{bcrank}}
}

\references{
 Ameur, A., Rada-Iglesias, A., Komorowski, J., Wadelius,
 C. Identification of candidate regulatory SNPs by combination of
 transcription factor binding site prediction, SNP genotyping and
 haploChIP. Nucleic Acids Res, 2009, 37(12):e85.
}

\keyword{methods}

\name{BCRANKout}
\alias{BCRANKout}
\docType{data}
\title{BCRANK results for USF1 ChIP-chip data}
\description{
  Results from running \code{bcrank} on USF1 whole genome ChIP-chip
  data for the human liver cell line HepG2. 
}
\usage{data(BCRANKout)}
\source{
  Data from whole genome ChIP-chip experiments on human liver cell line
  HepG2. (Rada-Iglesias, A., et \emph{al}. 2007)
}
\references{
  Rada-Iglesias, A., et \emph{al}. (2007) Whole-genome maps of USF1 and
  USF2 binding and histone H3 acetylation reveal new aspects of promoter
  structure and candidate genes for common human disorders.\emph{Genome
	Research}, Accepted
}
\seealso{
  \code{\link[BCRANK:bcrank]{bcrank}}
}

\keyword{datasets}

\name{BCRANKmatch-class}
\docType{class}
\alias{BCRANKmatch-class}
\alias{BCRANKmatch}
\alias{consensus}
\alias{bcrankScore}
\alias{matchVector}

\title{Class "BCRANKmatch"}

\description{Holds the \code{\link[BCRANK:bcrank]{bcrank}} score for one
	IUPAC consensus sequence. Several objects of this class are
	collected in a
	\code{\link[BCRANK:BCRANKsearch-class]{BCRANKsearch-class}} object}
\section{Objects from the Class}{
  Objects are not intended to be created directly but as a result from
  running \code{\link[BCRANK:bcrank]{bcrank}}.
}

\section{Slots}{
  \describe{
    \item{\code{consensus}:}{consensus sequence in IUPAC coding}
    \item{\code{bcrankScore}:}{bcrank score for the consensus}
	\item{\code{matchVec}:}{vector with 0's (no match) and 1's (match)
	  of same length as the ranked DNA sequences}
  }
}

\section{Methods}{
  \describe{
    \item{consensus}{\code{signature(object = "BCRANKmatch")}: Returns
	  the consensus sequence.}
	\item{bcrankScore}{\code{signature(object = "BCRANKmatch")}: Returns
	  the bcrank score.}
	\item{matchVector}{\code{signature(object = "BCRANKmatch")}: Returns
	  a vector with 0's (no match) and 1's (match) of same length and
	  order as the ranked DNA sequences.}
  }
}

\author{Adam Ameur, \email{adam.ameur@genpat.uu.se}}

\seealso{
  \code{\link[BCRANK:bcrank]{bcrank}},
  \code{\link[BCRANK:BCRANKsearch-class]{BCRANKsearch-class}}
}

\keyword{classes}

\name{bcrank}
\docType{methods}
\alias{bcrank}

\title{BCRANK: predicting binding site consensus from ranked DNA sequences}

\description{
  This function implements an algorithm for detection of short DNA
  sequences that are overrepresented in some part of the list. Starting
  from some initial consensus DNA sequence coded in IUPAC symbols, the
  method uses a heuristic search to improve the consensus until a local
  optimum is found. Individual predicted binding sites can
  be reported by the function \code{\link{matchingSites}}. 
}

\usage{
bcrank(fafile, startguesses=c(), restarts=10, length=10,
       reorderings=500, silent=FALSE, plot.progress=FALSE,
       do.search=TRUE, use.P1=FALSE, use.P2=TRUE, strip.desc=TRUE)
}

\arguments{
  \item{fafile}{a ranked fasta file containing DNA sequences.} 
  \item{startguesses}{a character vector with consensus sequences in
  IUPAC coding to be used as starting sequences in the search. If empty,
  random start guesses will be generated.}
  \item{restarts}{number restarts of the algorithm when using random start guesses.}
  \item{length}{legth of random start guess.}
  \item{reorderings}{number of random reorderings of the DNA sequences
	performed when calculating score.}
  \item{silent}{reports progress status if FALSE. }
  \item{plot.progress}{if TRUE, the progress is displayed in a plot.}
  \item{do.search}{if FALSE, no search is performed. In that case the
	start guesses are assigned with scores and reported as results.}
  \item{use.P1}{Use penalty for bases other than A,C,G,T.}
  \item{use.P2}{Use penalty for motifs matching repetitive sequences.}
  \item{strip.desc}{Ignored (always treated as TRUE).}
}

\value{
  The method returns an objcet of class \code{\link[BCRANK:BCRANKresult-class]{BCRANKresult-class}}.
}

\author{Adam Ameur, \email{adam.ameur@genpat.uu.se}}

\seealso{
  \code{\link{matchingSites}}, \code{\link[BCRANK:BCRANKresult-class]{BCRANKresult-class}}
}

\examples{
## Load example fasta file  
fastaFile <- system.file("Exfiles/USF1_small.fa", package = "BCRANK") 
## Run BCRANK
\dontrun{BCRANKout <- bcrank(fastaFile, restarts=20)}
\dontshow{data(BCRANKout)}
## Show BCRANK results
toptable(BCRANKout)
## The top scoring result
topMotif <- toptable(BCRANKout,1)
## Plot BCRANK search path
plot(topMotif)
## Position Weight Matrix
pwm(topMotif, normalize=FALSE)
}

\references{
 Ameur, A., Rada-Iglesias, A., Komorowski, J., Wadelius,
 C. Identification of candidate regulatory SNPs by combination of
 transcription factor binding site prediction, SNP genotyping and
 haploChIP. Nucleic Acids Res, 2009, 37(12):e85.
}

\keyword{methods}

\name{BCRANKsearch-class}
\docType{class}
\alias{BCRANKsearch-class}
\alias{BCRANKsearch}
\alias{searchPath}
\alias{pwm}
\alias{plot,BCRANKsearch,missing-method}

\title{Class "BCRANKsearch"}

\description{Holds the whole search path from a single
  \code{\link[BCRANK:bcrank]{bcrank}} run. Each individual search step
  is stored in a
  \code{\link[BCRANK:BCRANKmatch-class]{BCRANKmatch-class}}
  object.  Several objects of this class are collected in a
  \code{\link[BCRANK:BCRANKresult-class]{BCRANKresult-class}} object}

\section{Objects from the Class}{
  Objects are not intended to be created directly but as a result from
  running \code{\link[BCRANK:bcrank]{bcrank}}.
}

\section{Slots}{
  \describe{
    \item{\code{searchPath}:}{a collection of \code{BCRANKmatch-class}
	  objects, ontaining all bcrank search steps from a start guess to a
	  locally optimal solution.}
	\item{\code{final}:}{a \code{BCRANKmatch-class} object for the
	  highest scoring consensus sequence (locally optimal solution) in this bcrank run.}
	\item{\code{finalPWM}:}{position weight matrix for the highest
	  scoring consensus sequence.}
	\item{\code{finalNrMatch}:}{number of occurrences of the final
	  consensus sequence in the fasta input file.}
	\item{\code{nrIterations}:}{number of iterations required to move
	  from the start guess to the final soloution in this bcrank run.}
  }
}


\section{Methods}{
  \describe{
	\item{searchPath}{\code{signature(object = "BCRANKsearch", i=NULL)}:
	  If \code{i} is NULL, returns a data frame containing consensus and score
	  for the whole search path. Otherwise, the i'th
	  \code{BCRANKmatch-class} object in the search path is returned.}
    \item{pwm}{\code{signature(object = "BCRANKsearch", normalize=TRUE)}: Returns
	  the position weight matrix (pwm) for the highest scoring consensus in
	  this bcrank run. Matrix positions are between between 0 and 1 when \code{normalize}
	  is TRUE. When FALSE, the number of matching sequences is reported.}  
	  \item{plot}{\code{signature(x = "BCRANKsearch", y = "missing")}:
	 A plot method for the searchPath.}
 }
}

\author{Adam Ameur, \email{adam.ameur@genpat.uu.se}}

\seealso{
  \code{\link[BCRANK:bcrank]{bcrank}},
  \code{\link[BCRANK:BCRANKmatch-class]{BCRANKmatch-class}},
  \code{\link[BCRANK:BCRANKresult-class]{BCRANKresult-class}}
}

\keyword{classes}

\name{BCRANK-internal}
\docType{methods}
\alias{bcrankScore,BCRANKmatch-method}
\alias{consensus,BCRANKmatch-method}
\alias{matchVector,BCRANKmatch-method}
\alias{show,BCRANKmatch-method}
\alias{pwm,BCRANKsearch-method}
\alias{searchPath,BCRANKsearch-method}
\alias{show,BCRANKsearch-method}
\alias{fname,BCRANKresult-method}
\alias{toptable,BCRANKresult-method}
\alias{show,BCRANKresult-method}

\title{BCRANK-internal}
\description{Internal methods for the \pkg{BCRANK} package.}
\seealso{
  \code{\link[BCRANK:bcrank]{bcrank}}
}

\author{Adam Ameur, \email{adam.ameur@genpat.uu.se}}

\keyword{methods}
\keyword{internal}

\name{BCRANKresult-class}
\docType{class}
\alias{BCRANKresult-class}
\alias{BCRANKresult}
\alias{toptable}
\alias{fname}

\title{Class "BCRANKresult"}

\description{Holds the results from running
  \code{\link[BCRANK:bcrank]{bcrank}}. Contains a number of
  \code{\link[BCRANK:BCRANKsearch-class]{BCRANKsearch-class}} object,
  one for each restart of the bcrank search.}

\section{Slots}{
  \describe{
    \item{\code{fname}:}{the name of the fasta file used for running bcrank.}
    \item{\code{toplist}:}{a list of \code{BCRANKsearch-class} objects,
	  ranked by their scores.}
	\item{\code{funCall}:}{the function call that was made to bcrank.}
	\item{\code{nrSeqs}:}{number of sequences in the fasta input file.}
	\item{\code{restarts}:}{number of restarts used in the bcrank
	  search.}
  }
}

\section{Methods}{
  \describe{
    \item{fname}{\code{signature(object = "BCRANKmatch")}: Returns the
	  fasta file name.}
	\item{toplist}{\code{signature(object = "BCRANKmatch", i=NULL)}: If
	  \code{i} is NULL, returns a data frame containing consensus and
	  score for the results for each restart of the bcrank
	  search. Otherwise, the i'th \code{BCRANKsearch-class} object in
	  the toplist is returned.}
  }
}

\author{Adam Ameur, \email{adam.ameur@genpat.uu.se}}

\seealso{
  \code{\link[BCRANK:bcrank]{bcrank}},
  \code{\link[BCRANK:BCRANKsearch-class]{BCRANKsearch-class}},
}

\keyword{classes}
